/*
  Copyright Red Hat, Inc. 2005

  This program is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published by the
  Free Software Foundation; either version 2, or (at your option) any
  later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; see the file COPYING.  If not, write to the
  Free Software Foundation, Inc.,  675 Mass Ave, Cambridge, 
  MA 02139, USA.
*/
/*
 * Author: Stanko Kupcevic <kupcevic@redhat.com>
 */


#include "Except.h"


using namespace std;



Except::Except(long long error_code,
	       const String& msg) : 
  _code(error_code), _msg(msg)
{
  if (_code == generic_error)
    throw String("Exception() invalid error_code");
}

Except::~Except()
{}

long long 
Except::code() const
{
  return _code;
}

String 
Except::description() const
{
  return _msg;
}
